/* -*- mode: js2; js2-basic-offset: 4; indent-tabs-mode: nil -*- */

const Gio = imports.gi.Gio;
const Gtk = imports.gi.Gtk;
const GObject = imports.gi.GObject;
const Lang = imports.lang;

const Gettext = imports.gettext.domain('gnome-shell-extensions');
const _ = Gettext.gettext;
const N_ = function(e) { return e };

const IBusSettingsWidget = GObject.registerClass(
class IBusSettingsWidget extends Gtk.Box{
    _init (){
        super._init({orientation: Gtk.Orientation.HORIZONTAL,
                     spacing: 6,
                     margin_top: 36,
                     margin_bottom: 36,
                     margin_start: 36,
                     margin_end: 36,
                     halign: Gtk.Align.FILL,
                     valign: Gtk.Align.START,
                    });

        this._settings = new Gio.Settings({ schema_id: 'org.freedesktop.ibus.panel' });

        let fontLabel = '<b>' + _("IBus Candidates Font") + '</b>';
        this.append(new Gtk.Label({ label: fontLabel, use_markup: true,
                                    halign: Gtk.Align.START,}));

        let fontButton = new Gtk.FontButton({halign: Gtk.Align.END,});
        let fontName = "Sans 10";

        let useCustomFont = this._settings.get_boolean('use-custom-font');

        if (useCustomFont) {
            fontName = this._settings.get_string('custom-font');
        }

        fontButton.font = fontName;

        fontButton.connect('font-set', Lang.bind(this, function(widget) {
            fontName = widget.font;
            this._settings.set_boolean('use-custom-font', true);
            this._settings.set_string('custom-font', fontName);
        }));
        
        this.append(fontButton);
    }
});

function init() {
}

function buildPrefsWidget() {
    return new IBusSettingsWidget();
}
